Bug 917136

Summary: Review Request: nodejs-ws - websocket client, server and console for node.js
Product: [Fedora] Fedora Reporter: Troy Dawson <tdawson>
Component: Package ReviewAssignee: Jamie Nguyen <jamielinux>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: jamielinux, notting, package-review
Target Milestone: ---Flags: jamielinux: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Fixed In Version: nodejs-ws-0.4.25-3.fc19 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-06-07 00:47:27 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 956806, 917149    

Description Troy Dawson 2013-03-01 15:04:57 EST
Spec URL: http://tdawson.fedorapeople.org/nodejs/nodejs-ws.spec
SRPM URL: http://tdawson.fedorapeople.org/nodejs/nodejs-ws-0.4.25-1.fc18.src.rpm
Simple to use, blazing fast and thoroughly tested 
websocket client, server and console for node.js, 
up-to-date against RFC-6455

Fedora Account System Username: tdawson
Comment 1 Jamie Nguyen 2013-05-26 12:50:50 EDT
Package Review

[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Is python actually required for building?

- nodejs-ws.x86_64: W: summary-not-capitalized C websocket client, server and console for node.js

Summary needs to be capitalized.

- nodejs-ws.x86_64: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket

"websocket" should probably be two words.

nodejs-ws.x86_64: W: hidden-file-or-dir /usr/share/doc/nodejs-ws-0.4.25/examples/fileapi/.npmignore

Remove this file.

nodejs-ws.x86_64: W: no-manual-page-for-binary wscat

Consider adding a manual page (but this is a should not a must).

- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines

The version of the dependency on npm(commander) needs to be corrected (ie, made less specific).

- Permissions on files are set properly.
  Note: See rpmlint output
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions

A couple of files are 0775, probably should be 0755 instead.

===== MUST items =====

[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. Licenses found: "Unknown or generated". 2 files have
     unknown license. Detailed output of licensecheck in
[x]: Package consistently uses macro is (instead of hard-coded directory
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 51200 bytes in 15 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
[?]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
[x]: Large data in /usr/share should live in a noarch subpackage if package is

Installation errors
INFO: mock.py version 1.1.32 starting...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Mock Version: 1.1.32
INFO: Mock Version: 1.1.32
Start: lock buildroot
INFO: installing package(s): /home/mockbuild/review/nodejs-ws/results/nodejs-ws-0.4.25-1.fc18.x86_64.rpm
ERROR: Command failed: 
 # ['/usr/bin/yum', '--installroot', '/data/mock/fedora-18-x86_64/root/', 'install', '/home/mockbuild/review/nodejs-ws/results/nodejs-ws-0.4.25-1.fc18.x86_64.rpm', '--setopt=tsflags=nocontexts']
Error: Package: nodejs-ws-0.4.25-1.fc18.x86_64 (/nodejs-ws-0.4.25-1.fc18.x86_64)
           Requires: npm(commander) < 0.7
           Installed: nodejs-commander-1.1.1-1.fc18.noarch (@updates)
               npm(commander) = 1.1.1
 You could try using --skip-broken to work around the problem
Error: Package: nodejs-ws-0.4.25-1.fc18.x86_64 (/nodejs-ws-0.4.25-1.fc18.x86_64)
           Requires: npm(tinycolor) < 1
Error: Package: nodejs-ws-0.4.25-1.fc18.x86_64 (/nodejs-ws-0.4.25-1.fc18.x86_64)
           Requires: npm(options)
 You could try running: rpm -Va --nofiles --nodigest

Checking: nodejs-ws-0.4.25-1.fc18.x86_64.rpm
nodejs-ws.x86_64: W: spelling-error Summary(en_US) websocket -> web socket, web-socket, socket
nodejs-ws.x86_64: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-ws.x86_64: W: summary-not-capitalized C websocket client, server and console for node.js
nodejs-ws.x86_64: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket
nodejs-ws.x86_64: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-ws.x86_64: E: non-standard-executable-perm /usr/lib/node_modules/ws/validation.node 0775L
nodejs-ws.x86_64: E: non-standard-executable-perm /usr/lib/node_modules/ws/bufferutil.node 0775L
nodejs-ws.x86_64: W: hidden-file-or-dir /usr/share/doc/nodejs-ws-0.4.25/examples/fileapi/.npmignore
nodejs-ws.x86_64: W: no-manual-page-for-binary wscat
1 packages and 0 specfiles checked; 2 errors, 7 warnings.

nodejs-ws (rpmlib, GLIBC filtered):


Source checksums
http://registry.npmjs.org/ws/-/ws-0.4.25.tgz :
  CHECKSUM(SHA256) this package     : 1a413e4babf63aafc9efa1dcf421052d1b7585f5a723a449d90eb804cbcb4e58
  CHECKSUM(SHA256) upstream package : 1a413e4babf63aafc9efa1dcf421052d1b7585f5a723a449d90eb804cbcb4e58

Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-18-x86_64
Command line :/bin/fedora-review -r -n nodejs-ws-0.4.25-1.fc18.src.rpm
Comment 2 Troy Dawson 2013-05-29 11:03:31 EDT
Spec URL: http://tdawson.fedorapeople.org/nodejs/nodejs-ws.spec
SRPM URL: http://tdawson.fedorapeople.org/nodejs/nodejs-ws-0.4.25-2.fc18.src.rpm

- Spelling
-- Spelling fixed
- Capitalization
-- Captilization fixed
- Hidden file
-- Hidden file removed
- Bad/Odd permissions
-- 775 permissions changed to 755 on affected files
- npm(commander) dependancy problem
-- package.json fixed so commander can be >=0.6.1
- python
-- It shows up in build/config.gypi
-- It sorta shocked me as well, but it appears to need it.
- man page
-- I attempted to create a man page from the -h output, but there wasn't much there.
-- I went with no man page.
Comment 3 Jamie Nguyen 2013-05-29 11:19:44 EDT
Instead of using sed (or patch) you can also use %nodejs_fixdep:

  %nodejs_fixdep commander '>=0.6.1'

It's usage is documented somewhere, but I can't find it.

Anyway, looks good, package approved!
Comment 4 Troy Dawson 2013-05-29 11:35:34 EDT
Thank you for that hint about nodejs_fixdep
It is documented in /etc/rpm/macros.nodejs right above the macro.
Comment 5 Troy Dawson 2013-05-29 11:37:25 EDT
New Package SCM Request
Package Name: nodejs-ws
Short Description: websocket client, server and console for node.js
Owners: tdawson
Branches: f19 f18 el6
Comment 6 Jon Ciesla 2013-05-29 11:47:08 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2013-05-29 16:10:16 EDT
nodejs-ws-0.4.25-3.fc19 has been submitted as an update for Fedora 19.
Comment 8 Fedora Update System 2013-05-30 13:52:38 EDT
nodejs-ws-0.4.25-3.fc19 has been pushed to the Fedora 19 testing repository.
Comment 9 Fedora Update System 2013-06-07 00:47:27 EDT
nodejs-ws-0.4.25-3.fc19 has been pushed to the Fedora 19 stable repository.